﻿#pragma once
// Includes for Domain types
#include <Ice/BuiltinSequences.ice>

module Core {
	module Contracts {
		module DataTransferObject {
			/** 
			 * Forward declaration of a Decimal DTO Type
			**/
			class DecimalDto;

			/** 
			 * Forward declaration of a Guid DTO Type
			**/
			class GuidDto;

			/** 
			 * Forward declaration of a DateTime DTO Type
			**/
			class DateTimeDto;

			/** 
			 * Forward declaration of a Timespan DTO Type
			**/
			class TimeSpanDto;
			
			/** 
			 * Forward declaration of a Image DTO Type
			**/
			class ImageDto;

			/** 
			 * Forward declaration of a Object Type
			**/
			class ObjectDto;

			/** 
			 * Forward declaration of a Filter descriptor
			**/
			class FilterDescriptorDto;

			/** 
			 * Forward declaration of a Data request
			**/
			class DataSourceRequestDto;

			/** 
			 * Forward declaration of a Version
			**/
			class VersionDto;

			/** 
			 * Forward declaration of a Culture Text
			**/
			class CultureTextDto;

			/** 
			 * Forward declaration of a DatabaseConnectionInformation
			**/
			class CoreDatabaseConnectionInformationDto;

			/** 
			 * Forward declaration of a PasswordPolicyResultDto
			 **/
			class PasswordPolicyResultDto;
		};
	}; 
};
module Training {
	module ServiceContracts {
		module DataTransferObject {
			/** 
			 * Charge Sequence and Result
			 **/
			class ChargeDto;
			["clr:generic:List"]
			sequence<ChargeDto> ChargeDtoSeq;
			["clr:property"]
			class ChargeDtoResult
			{
				ChargeDtoSeq Data;
				int Total;
			};

			/** 
			 * ChargeInfo Sequence and Result
			 **/
			class ChargeInfoDto;
			["clr:generic:List"]
			sequence<ChargeInfoDto> ChargeInfoDtoSeq;
			["clr:property"]
			class ChargeInfoDtoResult
			{
				ChargeInfoDtoSeq Data;
				int Total;
			};

			/** 
			 * RegistrationPoint Sequence and Result
			 **/
			class RegistrationPointDto;
			["clr:generic:List"]
			sequence<RegistrationPointDto> RegistrationPointDtoSeq;
			["clr:property"]
			class RegistrationPointDtoResult
			{
				RegistrationPointDtoSeq Data;
				int Total;
			};

			/** 
			 * Define a string sequence
			**/
			["clr:generic:List"]
			sequence<string> StringDtoSeq;
			
			/** 
			 * Define a int sequence
			**/
			["clr:generic:List"]
			sequence<int> IntDtoSeq;
			
			/** 
			 * Define a double sequence
			**/
			["clr:generic:List"]
			sequence<double> DoubleDtoSeq;

			/** 
			 * Define a Guid Dto sequence
			**/
			["clr:generic:List"]
			sequence<Core::Contracts::DataTransferObject::GuidDto> GuidDtoSeq;

			/** 
			 * Define a Date Time Dto sequence
			**/
			["clr:generic:List"]
			sequence<Core::Contracts::DataTransferObject::DateTimeDto> DateTimeDtoSeq;

			/** 
			 * Define a Time Span Dto sequence
			**/
			["clr:generic:List"]
			sequence<Core::Contracts::DataTransferObject::TimeSpanDto> TimeSpanDtoSeq;

			/** 
			 * Define a image Dto sequence
			**/
			["clr:generic:List"]
			sequence<Core::Contracts::DataTransferObject::ImageDto> ImageDtoSeq;

			/** 
			 * Define a Culture text Dto sequence
			**/
			["clr:generic:List"]
			sequence<Core::Contracts::DataTransferObject::CultureTextDto> CultureTextDtoSeq;				

			/** 
			 * Define a object
			**/
			dictionary<string, string> ObjectMap;
			
			["clr:generic:List"]
			sequence<Core::Contracts::DataTransferObject::FilterDescriptorDto> FilterDescriptorDtoSeq;
		};
		module Interfaces {

			/** 
			 * Define a CommunicationException Type
			**/
			["cs:attribute:System.Runtime.CompilerServices.CompilerGeneratedAttribute"]
			exception CommunicationException {  
				int		ErrorCode;  
				string	Message;
				string  InnerTypeNameSpace;
				string	InnerTypeName;
				string	InnerTypeAssembly;
			}; 

		};
	};
};
	
 
